# -*- coding: utf-8 -*-

__authors__= "Juan Colino & Jorge Diez"
__email__= "juan.colino@gmail.com"
__license__= """
 --------------------------------------------------------------------------

 Waltz 0.1-beta3 - GTK Icon Management System
 Copyright (C) 2006 Juan Colino
 <juan.colino@gmail.com>

 --------------------------------------------------------------------------

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 --------------------------------------------------------------------------
"""

import gtk
import ConfigParser
import os

class Prefs:
    "Clase que almacena las preferencias"
    # Borg pattern - 
    # http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/66531

    __shared_state = {}

    # ================================================================
    #  Preferencias
    # ================================================================

    prefs_dict = {
    	'window width': 800,
	'window height': 600,
	'vectorial-editor': 'Inkscape',
	'vectorial-editor-cmd': 'inkscape',
	'bitmap-editor': 'GIMP',
	'bitmap-editor-cmd': 'gimp',
    }

    def __init__(self):
	self.__dict__ = self.__shared_state # Borg pattern

    def save_preferences(self):
	"Guarda las preferencias en un archivo de configuracion waltzrc"

	# FIXME: iterate this
	conf = ConfigParser.SafeConfigParser()
	conf.add_section('Display')
	conf.set('Display', 'window width', str(self.prefs_dict['window width']))
	conf.set('Display', 'window height', str(self.prefs_dict['window height']))
	conf.add_section('Launchers')
	conf.set('Launchers', 'vectorial-editor', self.prefs_dict['vectorial-editor'])
	conf.set('Launchers', 'vectorial-editor-cmd', self.prefs_dict['vectorial-editor-cmd'])
	conf.set('Launchers', 'bitmap-editor', self.prefs_dict['bitmap-editor'])
	conf.set('Launchers', 'bitmap-editor-cmd', self.prefs_dict['bitmap-editor-cmd'])
	conf.write(file(os.path.expanduser('~/.config/waltz/waltzrc'), 'w'))
	print 'Preferences saved in ~/.config/waltz/waltzrc'

    def load_preferences(self):
	"Carga las preferencias del archivo de configuracion waltzrc"

	# FIXME: iterate this
	conf = ConfigParser.SafeConfigParser()
	if os.path.isfile(os.path.expanduser('~/.config/waltz/waltzrc')):
	    conf.read(os.path.expanduser('~/.config/waltz/waltzrc'))
	    if conf.has_option('Display', 'window width'):
		self.prefs_dict['window width'] = int(conf.get('Display', 'window width'))
	    if conf.has_option('Display', 'window height'):
		self.prefs_dict['window height'] = int(conf.get('Display', 'window height'))
	    if conf.has_option('Launchers', 'vectorial-editor'):
		self.prefs_dict['vectorial-editor'] = conf.get('Launchers', 'vectorial-editor')
	    if conf.has_option('Launchers', 'vectorial-editor-cmd'):
		self.prefs_dict['vectorial-editor-cmd'] = conf.get('Launchers', 'vectorial-editor-cmd')
	    if conf.has_option('Launchers', 'bitmap-editor'):
		self.prefs_dict['bitmap-editor'] = conf.get('Launchers', 'bitmap-editor')
	    if conf.has_option('Launchers', 'bitmap-editor-cmd'):
		self.prefs_dict['bitmap-editor-cmd'] = conf.get('Launchers', 'bitmap-editor-cmd')
	else:
	    print 'No ~/.config/waltz/waltzrc config file found'

